using System;
using System.Collections.Generic;
using System.Text;

namespace LighthouseShared
{
    public class OwnerNotInChatException : Exception
    {
        public OwnerNotInChatException() 
            : base("The owner client is not in the chat")
        {

        }
    }

    public class NoOwnerException : Exception
    {
        public NoOwnerException()
            : base("Chat has no owner")
        {
        }
    }

    public class OwnershipNotAcquiredException : Exception
    {
        public OwnershipNotAcquiredException()
            : base("Ownership not acquired")
        {
        }
    }

    public class ClientNotSignedOnException : Exception
    {
        public ClientNotSignedOnException()
            : base("Client not signed on")
        {
        }
    }
}
