using System;
using System.Collections.Generic;
using System.Text;

namespace LighthouseShared
{
    public interface ICCOMPlugin
    {
        IList<ICommandInfo> List_Commands { get; }

        IList<IUserInfo> List_UsersHere { get; }
        IDictionary<string, IUserInfo> List_Users { get; }
        IList<IUserInfo> List_Bans { get; }

        ICommandInfo RegisterCommand(string name, string defaulttext, string help, IPlugin plugin, CommandCallback callback);
        void UnregisterCommand(ICommandInfo commandinfo);
        void UnregisterCommandsByPlugin(IPlugin plugin);

        void HandleMessage(string screenname, string message);
        void HandleUserJoin(string screenname);
        void HandleUserLeave(string screenname);
        void HandleChatJoin(IChatInfo chatinfo);
        void HandleChatLeave(IChatInfo chatinfo, LeaveReason reason);
        void HandleBan(string screenname);
        void HandleBanFailed(string screenname);
        void HandleUnban(string screenname);
        void HandleUnbanFailed(string screenname);
        void HandleKick(string screenname);
        void HandleKickFailed(string screenname);
    }
}
