using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using LighthouseShared;

namespace SimpleAutoban
{
    public partial class PanelAutoban : LighthouseShared.LHPanel
    {
        private SimpleAB m_AB;

        public PanelAutoban(SimpleAB ab)
        {
            m_AB = ab;
            this.PanelName = "Autoban";
            InitializeComponent();
        }

        private void checkBanGhost_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void PanelAutoban_Load(object sender, EventArgs e)
        {

        }

        private void radioBanNone_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void textAddAutoban_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Enter)
            {
                m_AB.CCOMAddAutoban(textAddAutoban.Text);
                textAddAutoban.Text = string.Empty;
                UpdateUI();
            }
        }

        private void textAddAutoban_TextChanged(object sender, EventArgs e)
        {

        }

        private void textAddWordban_TextChanged(object sender, EventArgs e)
        {

        }

        private void textAddWordban_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Enter)
            {
                m_AB.CCOMAddWordban(textAddWordban.Text);
                textAddWordban.Text = string.Empty;
                UpdateUI();
            }
        }

        private void removeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (listAutobans.SelectedItem != null)
            {
                m_AB.CCOMRemoveAutoban(listAutobans.SelectedItem.ToString());
                UpdateUI();
            }
        }

        private void removeAllToolStripMenuItem_Click(object sender, EventArgs e)
        {
            m_AB.m_Autobans.Clear();
            m_AB.m_PartialAutobans.Clear();
            UpdateUI();
        }

        private void removeToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            if (listWordbans.SelectedItem != null)
            {
                m_AB.CCOMRemoveWordban(listWordbans.SelectedItem.ToString());
                UpdateUI();
            }
        }

        private void removeAllToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            m_AB.m_Wordbans.Clear();
            UpdateUI();
        }



        public override void UpdateUI()
        {
            base.UpdateUI();

            foreach (string s in m_AB.m_PartialAutobans.Values)
            {
                string ab = "*" + s;

                if (!listAutobans.Items.Contains(ab))
                {
                    listAutobans.Items.Add(ab);
                }
            }

            foreach (string s in m_AB.m_Autobans.Values)
            {
                if (!listAutobans.Items.Contains(s))
                {
                    listAutobans.Items.Add(s);
                }
            }

            object[] abitems = new object[listAutobans.Items.Count];
            listAutobans.Items.CopyTo(abitems, 0);

            foreach (object o in abitems)
            {
                string s = (string)o;

                if (s.StartsWith("*"))
                {
                    if (!m_AB.m_PartialAutobans.ContainsKey(s.Substring(1)))
                    {
                        listAutobans.Items.Remove(o);
                    }
                }
                else
                {
                    if (!m_AB.m_Autobans.ContainsKey(s))
                    {
                        listAutobans.Items.Remove(o);
                    }
                }
            }


            foreach (string s in m_AB.m_Wordbans.Values)
            {
                if (!listWordbans.Items.Contains(s))
                {
                    listWordbans.Items.Add(s);
                }
            }

            object[] wbitems = new object[listWordbans.Items.Count];
            listWordbans.Items.CopyTo(wbitems, 0);

            foreach (object o in wbitems)
            {
                string s = (string)o;

                if (!m_AB.m_Wordbans.ContainsKey(s))
                {
                    listWordbans.Items.Remove(o);
                }
            }

        }

        private void listAutobans_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Right)
            {
                listAutobans.SelectedIndex = listAutobans.IndexFromPoint(e.Location);
            }
        }


        private void listWordbans_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Right)
            {
                listWordbans.SelectedIndex = listWordbans.IndexFromPoint(e.Location);
            }
        }
    }
}

