using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using LighthouseShared;

namespace Uccom3ishParser
{
    public partial class FormDefaultPerms : Form
    {
        private SimpleCCOM m_CCOMPlugin;

        public FormDefaultPerms(SimpleCCOM ccomplugin)
        {
            m_CCOMPlugin = ccomplugin;
            InitializeComponent();

            foreach (CommandInfo c in m_CCOMPlugin.m_Commands)
            {
                ListItem item = new ListItem(c.Command, c);
                checkedListBox1.Items.Add(item);
                if (m_CCOMPlugin.m_DefaultPermissions.Contains(c))
                    checkedListBox1.SetItemCheckState(checkedListBox1.Items.IndexOf(item), CheckState.Checked);
                else
                    checkedListBox1.SetItemCheckState(checkedListBox1.Items.IndexOf(item), CheckState.Unchecked);
            }
        }

        private void SetDefaultPerms_Load(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void checkedListBox1_ItemCheck(object sender, ItemCheckEventArgs e)
        {
            Console.WriteLine("checkstate: {0}", e.NewValue.ToString());
            CommandInfo commandinfo = (CommandInfo)((ListItem)checkedListBox1.Items[e.Index]).Tag;

            try
            {
                if (e.NewValue == CheckState.Checked && !m_CCOMPlugin.m_DefaultPermissions.Contains(commandinfo))
                    m_CCOMPlugin.m_DefaultPermissions.Add(commandinfo);
                else if (e.NewValue == CheckState.Unchecked)
                    m_CCOMPlugin.m_DefaultPermissions.Remove(commandinfo);
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
    }
}