using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using LighthouseShared;

namespace Uccom3ishParser
{
    public partial class PanelBansMisc : LighthouseShared.LHPanel
    {
        private SimpleCCOM m_CCOM;

        public PanelBansMisc(SimpleCCOM ccom)
        {
            this.PanelName = "Bans";
            m_CCOM = ccom;
            InitializeComponent();
        }

        private void PanelBansMisc_Load(object sender, EventArgs e)
        {

        }

        public override void UpdateUI()
        {
            base.UpdateUI();
            listBans.Items.Clear();
            foreach (IUserInfo ban in m_CCOM.m_Bans)
            {
                listBans.Items.Add(ban.ScreenName);
            }
            labelBanCount.Text = m_CCOM.m_Bans.Count.ToString();
        }

        private void listBans_SelectedIndexChanged(object sender, EventArgs e)
        {
            IUserInfo user = m_CCOM.m_Users[listBans.SelectedItem.ToString()];

            textBannedBy.Text = user.BannedBy;
        }

        private void showAlphabeticallyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            listBans.Sorted = true;
        }

        private void unbanToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (listBans.SelectedItem != null)
            {
                m_CCOM.CCOMUnban(listBans.SelectedItem.ToString());
            }
        }

        private void listBans_MouseClick(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Right)
            {
                listBans.SelectedIndex = listBans.IndexFromPoint(e.Location);
            }
        }
    }
}

